<?php
ini_set('register_globals', '1');
require_once dirname(__FILE__) . '/config.inc.php';
require_once dirname(__FILE__) . '/classes/IWFCampusmedienLitSearch.class.php';
require_once dirname(__FILE__) . '/classes/IWFCampusmedienLitList.class.php';
require_once dirname(__FILE__) . '/classes/IWFCampusmedienViewAutor.class.php';
require_once dirname(__FILE__) . '/classes/IWFCampusmedienViewDozent.class.php';
require_once dirname(__FILE__) . '/classes/IWFCampusmedienActionHandler.class.php';
require_once dirname(__FILE__) . '/classes/IWFCampusmedienActionHandlerAutor.class.php';
require_once dirname(__FILE__) . '/classes/IWFCampusmedienActionHandlerDozent.class.php';



class IWFCampusmedienPlugin extends AbstractStudIPStandardPlugin {
	
	var $list;
	var $template_name;
	var $template;
	
	function IWFCampusmedienPlugin () {
		parent::AbstractStudIPStandardPlugin();
		$this->setPluginIconName('images/iwf_icon.jpg');
		$this->list =& new IWFCampusmedienLitList();
		
	}
	
	function setPluginpath ($newpath) {
		parent::setPluginpath($newpath);
		$this->buildMenu();
	}

	function buildMenu () {
		global $SessSemName, $perm;
		$tab = new PluginNavigation();
		$tab->setDisplayname(_("Campusmedien"));
		$tab->setActive();
		
		if ($perm->have_studip_perm("tutor",$SessSemName[1])) {
			$subnav = new PluginNavigation();
			$subnav->setDisplayname(_("Campusmedien bearbeiten"));
			$subnav->setActive();
			$subnav->setLinkParam("edit_list");
			$tab->addSubmenu($subnav);
			if ($_REQUEST['plugin_subnavi_params'] == 'edit_list') {
				$this->template_name = 'IWFCampusmedien_dozent_template';
			} else {
				$this->template_name = 'IWFCampusmedien_autor_template';
			}
		} else if ($perm->have_studip_perm("autor",$SessSemName[1])) {
			$this->template_name = 'IWFCampusmedien_autor_template';
		}
		
		$this->setNavigation($tab); 
	}

	function getNavigation() {
		return $this->navigation;
	}

	function getPluginName() {
		return 'IWFCampusmedien';
	}
	
	function hasChanged ($lastlogin) {
		$this->setPluginIconName('images/icon_campusmedien.gif');
		$this->setChangeIndicatorIconName('images/icon_campusmedien2.gif');
		return $lastlogin < IWFCampusmedienLitList::GetChangeDate($this->getId());
	}
	
	function isShownInOverview () {
	
		return true;
	}
	
	function getOverviewMessage ($has_changed) {
		if ($has_changed) {
			return _("Neue/genderte Medienliste");
		}
		return _("Medienliste verfgbar");
	}
	
	function show () {
		global $SessSemName, $perm;
		
		$GLOBALS['template_factory']->set_path(dirname(__FILE__) . '/templates');
		$this->template = $GLOBALS['template_factory']->open($this->template_name);
		$GLOBALS['template_factory']->set_path($GLOBALS['STUDIP_BASE_PATH'] . '/templates');
		if ($perm->have_studip_perm('tutor', $SessSemName[1])) {
			if ($_REQUEST['plugin_subnavi_params'] == 'edit_list') {
				$view =& new IWFCampusmedienViewDozent($this);
				$action_handler =& new IWFCampusmedienActionHandlerDozent($this, $view);
				$view->showSearch();
				$view->showList();
				$view->showResult();
				$view->showMessages();
				$view->showInfoBox();
			} else {
				$view =& new IWFCampusmedienViewAutor($this);
				$action_handler =& new IWFCampusmedienActionHandlerAutor($this, $view);
				$view->showList();
			}
		} else if ($perm->have_studip_perm('autor', $SessSemName[1])) {
			$view =& new IWFCampusmedienViewAutor($this);
			$action_handler =& new IWFCampusmedienActionHandlerAutor($this, $view);
			$view->showList();
		}
		
		echo $this->template->render();
	}
}
