<?
require_once 'lib/classes/StudipLitListViewAdmin.class.php';
require_once 'lib/datei.inc.php';

class IWFCampusmedienActionHandlerDozent extends IWFCampusmedienActionHandlerAutor {

	function IWFCampusmedienActionHandlerDozent (&$parent, &$view, $default_action = null) {
		parent::IWFCampusmedienActionHandlerAutor($parent, $view, $default_action);
	}
	
	function actionAddToList () {
		$catalog_id = $_REQUEST['catalog_id'];
		$element = $this->view->search->getSearchResult($_GET['search_id']);
	//	$this->view->search->setStartResult($_REQUEST['start_result']);
		if (!strpos($element->getValue('dc_format'), 'flash')) {
			$this->view->addMessage('error' . _("Element konnte der Medienliste nicht hinzugefgt werden"));
			return false;
		}
		if ($catalog_id{0} == '_') {
			$parts = explode('__', $catalog_id);
			if ($fields = $GLOBALS[$parts[0]][$parts[1]]) {
				$cat_element = new StudipLitCatElement();
				$cat_element->setValues($fields);
				$cat_element->setValue('catalog_id', 'new_entry');
				$cat_element->setValue('user_id', 'studip');
				if (($existing_element = $cat_element->checkElement())) {
					$cat_element->setValue('catalog_id', $existing_element);
				}
				if ($affected_rows = $cat_element->insertData()) {
					$catalog_id = $cat_element->getValue('catalog_id');
				}
				$GLOBALS[$parts[0]][$parts[1]]['catalog_id'] = $catalog_id;
			} else {
			print_r($this->view);
				$this->view->addMessage('error' . _("Element konnte der Medienliste nicht hinzugefgt werden"));
				return false;
			}
		}
		if (!$this->view->tree->isElement($catalog_id)) {
			if ($this->view->tree->insertElementBulk(array($catalog_id), $this->view->list_id)) {
				$this->view->addMessage('msg' . _("Ein Element der Medienliste hinzugefgt."));
				$this->view->updateView();
				return true;
			}
		}
		$this->view->addMessage('error' . _("Element konnte der Medienliste nicht hinzugefgt werden"));
		return false;
	}
		
	function actionDeleteFromList () {
		$item_id = $_REQUEST['item_id'];
		$this->view->tree->deleteElement($item_id);
		$this->view->updateView();
	}
	
	function actionMoveUp () {
		$this->orderItem('up');
		$this->view->updateView();
	}
	
	function actionMoveDown () {
		$this->orderItem('down');
		$this->view->updateView();
	}
	
	function orderItem ($direction) {
		$item_id = $_REQUEST['item_id'];
		$items_to_order = $this->view->tree->getKids($this->view->tree->tree_data[$item_id]['parent_id']);
		if (!$items_to_order){
			return false;
		}
		for ($i = 0; $i < count($items_to_order); ++$i){
			if ($item_id == $items_to_order[$i])
				break;
		}
		if ($direction == 'up' && isset($items_to_order[$i-1])){
			$items_to_order[$i] = $items_to_order[$i-1];
			$items_to_order[$i-1] = $item_id;
		} elseif (isset($items_to_order[$i+1])){
			$items_to_order[$i] = $items_to_order[$i+1];
			$items_to_order[$i+1] = $item_id;
		}
		for ($i = 0; $i < count($items_to_order); ++$i){
			if ($this->view->tree->isElement($item_id)){
				$this->view->tree->updateElement(array('priority' => $i, 'list_element_id' => $items_to_order[$i]));
			} else {
				$this->view->tree->updateList(array('priority' => $i, 'list_id' => $items_to_order[$i]));
			}
		}
		$this->view->addMessage('msg' . (($direction == 'up') ? _("Element wurde um eine Position nach oben verschoben.") : _("Element wurde um eine Position nach unten verschoben.")));
		return true;
	}
	
	function actionToggleVisibility () {
		$this->view->updateView();
	}
	
	function actionSetStartResult () {
		$this->view->search->setStartResult($_REQUEST['start_result']);
	}
	
	function actionToggleShowDetails () {
		if (!isset($_SESSION['plugin_IWFCampusmedien']['detailed_elements'])) {
			$_SESSION['plugin_IWFCampusmedien']['detailed_elements'] = array();
		}
		$catalog_id = $_REQUEST['catalog_id'];
		if (false !== ($index = array_search($catalog_id, $_SESSION['plugin_IWFCampusmedien']['detailed_elements']))) {
			unset($_SESSION['plugin_IWFCampusmedien']['detailed_elements'][$index]);
		} else {
			array_push($_SESSION['plugin_IWFCampusmedien']['detailed_elements'], $catalog_id);
		}
	}
	
	function actionCreateList () {
		$new_item_id = md5(uniqid("IWFCampusmedien", 1));
		$this->view->tree->tree_data[$new_item_id] = array(
			'chdate' => time(),
			'format'=> $this->view->tree->format_default,
			'user_id' => $GLOBALS['auth']->auth['uid'],
			'username' => $GLOBALS['auth']->auth['uname'],
			'fullname' => get_fullname($GLOBALS['auth']->auth['uid'],'no_title_short'),
			'visibility' => 0
			);
		$this->view->tree->storeItem($new_item_id, 'root', _("Neue Liste"),$this->view->tree->getMaxPriority($item_id) + 1);
		$this->view->showCreateList($new_item_id);
	}
	
	function actionInsertList () {
		$user_id = $GLOBALS['auth']->auth['uid'];
		$item_id = $_REQUEST['item_id'];
		$priority = $this->view->tree->getMaxPriority($parent_id) + 1;
		$affected_rows = $this->view->tree->insertList(array('list_id' => $item_id, 'priority' => $priority, 'format' => $this->view->tree->format_default, 'visibility' => $_REQUEST['edit_visibility'], 'name' => $_REQUEST['edit_name'], 'user_id' => $user_id, 'note' => $_REQUEST['list_note']));
		if ($affected_rows) {
			$this->view->addMessage("msg" . _("Sie haben eine neue Medienliste angelegt."));
		} else {
			$this->view->addMessage("error" . _("Die Medienliste konnte nicht angelegt werden."));
		}
		$this->view->list_id = $this->view->tree->haveList();
	}
	
	function actionAssertDeleteList () {
		$this->view->addMessage("info" ._("Sie beabsichtigen diese Liste inklusive aller Eintr&auml;ge, zu l&ouml;schen. ")
						. sprintf(_("Es werden insgesamt %s Eintr&auml;ge gel&ouml;scht!"),count($this->view->tree->getKidsKids($this->view->list_id)))
						. "<br>" . _("Wollen Sie diese Liste wirklich l&ouml;schen?") . "<br>"
						. "<a href=\"" . $this->view->getLink(array('action' => 'DeleteList', 'list_id' => $this->view->list_id)) . "\">"
						. "<img " .makeButton("ja2","src") . tooltip(_("lschen"))
						. " border=\"0\"></a>&nbsp;"
						. "<a href=\"" . $this->view->getLink() . "\">"
						. "<img " .makeButton("nein","src") . tooltip(_("abbrechen"))
						. " border=\"0\"></a>");
		return false;
	}
	
	function actionEditList () {
		$this->view->showEditList();
	}
	
	function actionUpdateList () {
		$user_id = $GLOBALS['auth']->auth['uid'];
		$affected_rows = $this->view->tree->updateList(array('list_id' => $this->view->list_id, 'format' => $this->view->tree->format_default, 'name' => $_REQUEST['edit_name'], 'visibility' => $_REQUEST['edit_visibility'], 'user_id' => $user_id, 'note' => $_REQUEST['list_note']));
		if ($affected_rows) {
			$this->view->addMessage('msg' . _("Eigenschaften der Medienliste wurden gendert."));
			$this->view->updateView();
		} else {
			$this->view->addMessages('error$' . _("Medienliste konnte nicht bearbeitet werden"));
		}
	}
	
	function actionDeleteList () {
		$item_id = $_REQUEST['list_id'];
		$deleted = 0;
		$item_name = $this->view->tree->tree_data[$item_id]['name'];
		$deleted = $this->view->tree->deleteList($item_id);
		if ($deleted){
			$this->view->addMessage("msg" . sprintf(_("Die Liste <b>%s</b> und alle Eintr&auml;ge (insgesamt %s) wurden gel&ouml;scht. "), htmlReady($item_name), $deleted - 1));
		} else {
			$this->view->addMessage("error" . _("Fehler, die Liste konnte nicht gel&ouml;scht werden!"));
		}
		$this->view->list_id = false;
		return true;
	}
	
	function actionDoSearch () {
		if ($this->view->search->outer_form->isClicked("search")
			|| ($this->view->search->outer_form->isSended()
			&& !$this->view->search->outer_form->isClicked("reset")
			&& !$this->view->search->outer_form->isClicked("change")
			&& !$this->view->search->outer_form->isClicked("search_add")
			&& !$this->view->search->outer_form->isClicked("search_sub")
			&& !$this->view->search->outer_form->isChanged("search_plugin"))) {
			
			$term_count_check = 0;
			if (isset($_POST['find_only_media']) || !$_SESSION['plugin_IWFCampusmedien']['extended_search']) {
				$_SESSION['plugin_IWFCampusmedien']['find_only_media'] = 1;
				$term_count = $this->view->search->term_count;
				$this->view->search->term_count++;
				$this->view->search->inner_form->form_values['search_term_'.$term_count] = 'code';
				$this->view->search->inner_form->form_values['search_field_'.$term_count] = '8618';
				$this->view->search->inner_form->form_values['search_truncate_'.$term_count] = 'right';
				$this->view->search->inner_form->form_values['search_operator_'.$term_count] = 'AND';
				$term_count_check++;
			} else {
				$_SESSION['plugin_IWFCampusmedien']['find_only_media'] = 0;
			}
			
			if (isset($_POST['find_only_flash']) || !$_SESSION['plugin_IWFCampusmedien']['extended_search']) {
				$_SESSION['plugin_IWFCampusmedien']['find_only_flash'] = 1;
				$term_count = $this->view->search->term_count;
				$this->view->search->term_count++;
				$this->view->search->inner_form->form_values['search_term_'.$term_count] = 'flash';
				$this->view->search->inner_form->form_values['search_field_'.$term_count] = '8621';
				$this->view->search->inner_form->form_values['search_truncate_'.$term_count] = 'right';
				$this->view->search->inner_form->form_values['search_operator_'.$term_count] = 'AND';
				$term_count_check++;
			} else {
				$_SESSION['plugin_IWFCampusmedien']['find_only_flash'] = 0;
			}
			
			if (isset($_POST['find_only_no_sequence']) || !$_SESSION['plugin_IWFCampusmedien']['extended_search']) {
				$_SESSION['plugin_IWFCampusmedien']['find_only_no_sequence'] = 1;
				$term_count = $this->view->search->term_count;
				$this->view->search->term_count++;
				$this->view->search->inner_form->form_values['search_term_'.$term_count] = 'start';
				$this->view->search->inner_form->form_values['search_field_'.$term_count] = '8618';
				$this->view->search->inner_form->form_values['search_truncate_'.$term_count] = 'right';
				$this->view->search->inner_form->form_values['search_operator_'.$term_count] = 'NOT';
				$term_count_check++;
			} else {
				$_SESSION['plugin_IWFCampusmedien']['find_only_no_sequence'] = 0;
			}
			
			$hits = $this->view->search->doSearch();
			$this->view->search->term_count -= $term_count_check;
			if (!$this->view->search->search_plugin->getNumError()) {
				$this->view->addMessage("msg" . sprintf(_("Ihre Suche ergab %s Treffer."), $this->view->search->getNumHits()) . "");
			}
			$this->view->search->start_result = 1;
		}
		$this->view->addMessage($this->view->search->search_plugin->getError("msg"));
		
		if (($num_hits = $this->view->search->getNumHits())) {
			if ($this->view->search->start_result < 1 || $this->view->search->start_result > $num_hits) {
				$this->view->search->start_result = 1;
			}
		//	$end_result = (($this->view->search->start_result + 5 > $num_hits) ? $num_hits : $this->view->search->start_result + 4);
		}
		
	}
	
	function actionToggleSearch () {
		$this->view->search->outer_form->doFormReset();
		$this->view->search->search_plugin->doResetSearch();
		$this->view->search->term_count = 1;
		if (!isset($_SESSION['plugin_IWFCampusmedien']['extended_search'])) {
			$_SESSION['plugin_IWFCampusmedien']['extended_search'] = 0;
		}
		if ($_SESSION['plugin_IWFCampusmedien']['extended_search']) {
			$_SESSION['plugin_IWFCampusmedien']['extended_search'] = 0;
		} else {
			$_SESSION['plugin_IWFCampusmedien']['extended_search'] = 1;
		}
		$_SESSION['plugin_IWFCampusmedien']['find_only_media'] = 1;
		$_SESSION['plugin_IWFCampusmedien']['find_only_flash'] = 1;
		$_SESSION['plugin_IWFCampusmedien']['find_only_no_sequence'] = 1;
	}
	
	function actionCancel () {
		
	}
	
	function actionLinkSelectFolder () {
		
		if (isset($_SESSION['plugin_IWFCampusmedien']['link_selected_item'])) {
			unset($_SESSION['plugin_IWFCampusmedien']['link_selected_item']);
		}
		$_SESSION['plugin_IWFCampusmedien']['link_selected_item'] = $_REQUEST['item_id'];
		$this->view->showSelectFolder();
	}
	/*
	function actionLinkItem () {
		
		if (!$_REQUEST['link_x']) {
			$this->view->showSelectFolder($_REQUEST['select_seminar']);
		} else {
			$result_var_name = '_search_result_studiplitsearchplugin' . strtolower($this->view->search->getPreferedPlugin);
			$element = $this->view->search->getSearchResult([$_REQUEST['search_id']]);
			global $the_link, $name, $description, $protect;
			$selected_sem = $_REQUEST['select_seminar'];
			$selected_folder = $_REQUEST['select_folder'];
			$item_id = $_SESSION['plugin_IWFCampusmedien']['link_selected_item'];
			$the_link = urldecode($_SESSION['plugin_IWFCampusmedien']['search_result'][$item_id]['movie_url']);
			$name = $_SESSION['plugin_IWFCampusmedien']['search_result'][$item_id]['short_name'];
			$description = $_SESSION[$result_var_name][$_REQUEST['search_id']]['dc_description'];
			$protect = 1;
			
			if (link_item($selected_folder, true)) {
				$sem_name = get_object_name($selected_sem, 'sem');
				$this->view->addMessage('msg' . sprintf(_("Das Medium \"%s\" wurde im Dateibereich der Veranstaltung \"%s\" im Ordner \"%s\" verlinkt."), $_SESSION['plugin_IWFCampusmedien']['search_result'][$item_id]['short_name'], $sem_name['name'], $this->getFolderName($selected_folder)));
			} else {
				$this->view->addMessage('error' . _("Medium konnte nicht verlinkt werden."));
			}
		}
		
	}
	*/
	
	function actionLinkItem () {
		if (!$_REQUEST['link_x']) {
			$this->view->showSelectFolder($_REQUEST['select_seminar']);
		} else {
			$result_var_name = '_search_result_studiplitsearchplugin' . strtolower($this->view->search->getPreferedPlugin);
			$element = $this->view->search->getSearchResult($_REQUEST['search_id']);
			$link = trim($element->getValue('dc_identifier'));
			$name = $element->getShortName();
			$description = $element->getValue('dc_description');
			if (strpos($element->getValue('dc_format'), 'flash') && $this->linkItem($link, $name, $description)) {
				$sem_name = get_object_name($_REQUEST['select_seminar'], 'sem');
				$this->view->addMessage('msg' . sprintf(_("Das Medium \"%s\" wurde im Dateibereich der Veranstaltung \"%s\" im Ordner \"%s\" verlinkt."), $name, $sem_name['name'], $this->getFolderName($_REQUEST['select_folder'])));
			} else {
				$this->view->addMessage('error' . _("Medium konnte nicht verlinkt werden."));
			}
		}
		
	}
	
	function linkItem ($ident_url, $name, $description) {
		if (!$GLOBALS['perm']->have_studip_perm('tutor', $_SESSION['SessionSeminar'])) {
			return false;
		}
		$db =& new DB_Seminar();
		$query = "SELECT folder_id FROM folder WHERE folder_id = '" .  mysql_escape_string($_REQUEST['select_folder']) . "' AND range_id = '" . mysql_escape_string($_REQUEST['select_seminar']) . "'";
		$db-> query($query);
		if ($db->next_record()) {
			$file_name = IWFCampusmedienLitList::GetMediaId($ident_url) . '.flv';
			$new_id = md5(uniqid('plugin_IWFCampusmedien', true));
			$query = "INSERT INTO dokumente SET
					dokument_id = '$new_id',
					seminar_id = '" . mysql_escape_string($_REQUEST['select_seminar']) . "',
					range_id = '" . mysql_escape_string($_REQUEST['select_folder']) . "',
					user_id = '{$GLOBALS['user']->id}',
					name = '" . mysql_escape_string($name) . "',
					description = '" . mysql_escape_string($description) . "',
					filename = '$file_name',
					mkdate = UNIX_TIMESTAMP(),
					chdate = UNIX_TIMESTAMP(),
					filesize = 0,
					autor_host = '{$_SERVER['REMOTE_ADDR']}',
					downloads = 0,
					url = '" . mysql_escape_string(IWFCampusmedienLitList::GetMovieUrl($ident_url)) . "',
					protected = 1";
			$db->query($query);
			if ($db->affected_rows()) {
				return true;
			}
			return false;
		}
		return false;
	}
		
	
	function getFolderName ($folder_id) {
		$db =& new DB_Seminar();
		$db->query("SELECT name FROM folder WHERE folder_id = '$folder_id'");
		while ($db->next_record()) {
			return $db->f('name');
		}
		return false;
	}
	
	function actionEditItem () {
		$item_id = $_REQUEST['item_id'];
		$this->view->setEditItemId($item_id);
	}
	
	function actionUpdateItem () {
		$item_id = $_REQUEST['item_id'];
		$affected_rows = $this->view->tree->updateElement(array('list_element_id' => $item_id, 'note' => $_REQUEST['edit_note'], 'user_id' => $GLOBALS['user']->id));
		if ($affected_rows) {
			$this->view->addMessage('msg' . _("Anmerkung wurde ge&auml;ndert."));
			$this->view->updateView();
		} else {
			$this->view->addMessage('error' . _("Anmerkung konnte nicht gendert werden."));
		}
	}


}

?>