<?
// +---------------------------------------------------------------------------+
// This file is part of Stud.IP
// IWFCampusmedienLitList.class.php
//
//
// Copyright (c) 2007 Peter Thienel <thienel@data-quest.de>
// Suchi & Berg GmbH <info@data-quest.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+

require_once("lib/classes/StudipLitList.class.php");


/**
* class to handle the
*
* This class provides
*
* @access	public
* @author	Peter Thienel <thienel@data-quest.de>
* @version	$Id: IWFCampusmedienLitListWrapper.class.php 8366 2007-10-10 10:23:46Z pthiene $
* @package
*/
class IWFCampusmedienLitList extends StudipLitList {

	function IWFCampusmedienLitList ($range_id = '') {
		global $sess;
		$sess->register('_search_result_studiplitsearchpluginiwfdigiclips');
		
		parent::StudipLitList($range_id);
		$this->format_default = "**{dc_creator}** |({dc_contributor})||\n"
		                       . "{dc_title}||\n"
		                       . "{dc_identifier}||\n"
		                       . "%%{published}%%||\n"
		                       . "{note}||\n"
		                       . "[{lit_plugin}]{external_link}|\n";
		$db =& new DB_Seminar();
		$db->query("SELECT list_id, note FROM plugin_campusmedien_lit_list WHERE range_id = '$range_id'");
		if ($db->next_record()) {
			$this->tree_data[$db->f('list_id')]['note'] = $db->f('note');
		}
	}
	
	function GetTabbedList ($range_id, $list_id) {
		$end_note_map = array(	'dc_type' => 'Reference Type', 'dc_title' => 'Title', 'dc_creator' => 'Author',
								'year' => 'Year', 'dc_contributor' => 'Secondary Author', 'dc_publisher' => 'Publisher',
								'dc_identifier' => 'ISBN/ISSN', 'dc_source' => 'Original Publication', 'dc_subject' => 'Keywords',
								'dc_description' => 'Abstract', 'accession_number' => 'Accession Number', 'note' => 'Notes', 'external_link' => 'URL');
		$dbv = new DbView();
		$tree =& TreeAbstract::GetInstance("IWFCampusmedienLitList", $range_id);
		$ret = "*Generic\n";
		foreach ($end_note_map as $fields){
			$ret .= $fields . "\t";
		}
		$ret .= "\n";
		if ($tree->hasKids($list_id)){
			$dbv->params[0] = $list_id;
			$rs = $dbv->get_query("view:LIT_LIST_GET_ELEMENTS");
			while ($rs->next_record()){
				$tree->cat_element->setValues($rs->Record);
				$tree->cat_element->fields['note']['value'] = $tree->tree_data[$rs->f('list_element_id')]['note'];
				foreach ($end_note_map as $studip_field => $end_note_field){
					$value = $tree->cat_element->getValue($studip_field);
					if ($studip_field == 'dc_type'
					&& ($value == '' || !in_array($value, $tree->cat_element->fields['dc_type']['select_list']))){
						$value = "Book";
					}
					$value = str_replace(array("\n","\r","\t"),'',$value);
					$ret .= $value . "\t";
				}
				$ret .= "\n";
			}
		}
		return $ret;
	}
	
	function GetFormattedListsByRange ($range_id, $last_modified_since = false, $copy_link = true) {
		$ret = false;
		$dbv = new DbView();
		$tree =& TreeAbstract::GetInstance("IWFCampusmedienLitList", $range_id);
		if ( ($lists = $tree->getVisibleListIds()) ) {
			for ($i = 0; $i < count($lists); ++$i) {
				if ( ($tree->tree_data[$lists[$i]]['user_id'] != $GLOBALS['auth']->auth['uid'])
				&& ($last_modified_since !== false)
				&& ($tree->tree_data[$lists[$i]]['chdate'] > $last_modified_since) ) {
					$ret .= '<div align="left" style="color:red" title="' . htmlReady(sprintf(_("Letzte nderung am %s von %s"),
					date('d M Y H:i',$tree->tree_data[$lists[$i]]['chdate']),
					$tree->tree_data[$lists[$i]]['fullname'])) . '">';
					$ret .=  "<b><u>" . htmlReady($tree->tree_data[$lists[$i]]['name']) . "</u></b>\n<br>\n";
					$ret .= '</div>';
				} else {
					$ret .= "\n<div align=\"left\"><b><u>" . htmlReady($tree->tree_data[$lists[$i]]['name']) . "</u></b></div>";
				}
				if ($copy_link) {
					$ret .= "\n<div align=\"right\" style=\"font-size:10pt\"><a href=\"admin_lit_list.php?cmd=CopyUserList&_range_id=self&user_list={$lists[$i]}#anchor\"><img src=\"".$GLOBALS['ASSETS_URL']."images/link_intern.gif\" border=\"0\">"
						. "&nbsp;" . _("Literaturliste kopieren") . "</a></div>";
				} else {
					$ret .= "\n<br>\n";
				}
				$ret .= "\n<span style=\"font-size:10pt\">\n";
				if ($tree->hasKids($lists[$i])) {
					$dbv->params[0] = $lists[$i];
					$rs = $dbv->get_query("view:LIT_LIST_GET_ELEMENTS");
					while ($rs->next_record()) {
						if ( ($tree->tree_data[$rs->f('list_element_id')]['user_id'] != $GLOBALS['auth']->auth['uid'])
						&& ($last_modified_since !== false)
						&& ($tree->tree_data[$rs->f('list_element_id')]['chdate'] > $last_modified_since) ){
							$ret .= '<span style="color:red" title="' . htmlReady(sprintf(_("Letzte nderung am %s von %s"),
							date('d M Y H:i',$tree->tree_data[$rs->f('list_element_id')]['chdate']),
							$tree->tree_data[$rs->f('list_element_id')]['fullname'])) . '">';
							$ret .=  formatReady($tree->getFormattedEntry($rs->f('list_element_id'), $rs->Record), false, true) . "\n<br>\n";
							$ret .= '</span>';
						} else {
							$ret .=  formatReady($tree->getFormattedEntry($rs->f('list_element_id'), $rs->Record), false, true) . "\n<br>\n";
						}
					}
				}
				$ret .= "\n</span><br>";
			}
		}
		return $ret;
	}
	
	function GetPreviewImageUrl($ident_url, $high_resolution = false) {
		if( ereg( 'code=([0-9]+)', $ident_url, $treffer ) ) {
			$media_id = $treffer[1];
		}
		if( $media_id == "" ) {
			return false;
		}
		$preview_image_url = CAMPUSMEDIEN_PREVIEW_IMAGE_URL . $media_id . "_";
		if( $high_resolution == false ) {
			$preview_image_url .= "lo";
		} else {
			$preview_image_url .= "hi";
		}
		$preview_image_url .= ".jpg";
		return $preview_image_url;
	}

	function GetMovieProvider ($ident_url, $high_resolution = true) {
		$frames_per_second = 25;
		if(!$media_id = IWFCampusmedienLitList::GetMediaId($ident_url)) {
			return '';
		}
		if( ereg( '&start=([0-9]{2}:[0-9]{2}:[0-9]{2}:[0-9]{2})', $ident_url, $treffer ) ) {
			$time_code = explode( ':', $treffer[1] );
			$startframe = ( $time_code[0] * 60 * 60 * $frames_per_second ) + ( $time_code[1] * 60 * $frames_per_second ) + ( $time_code[2] * $frames_per_second ) + $time_code[3];
		}
		if( ereg( '&end=([0-9]{2}:[0-9]{2}:[0-9]{2}:[0-9]{2})', $ident_url, $treffer ) ) {
			$time_code = explode( ':', $treffer[1] );
			$endframe = ( $time_code[0] * 60 * 60 * $frames_per_second ) + ( $time_code[1] * 60 * $frames_per_second ) + ( $time_code[2] * $frames_per_second ) + $time_code[3];
		}
		$movie_provider = 'flvprovider.php?flv_id=' . $media_id;
	
		// verschiedene Auflsungen werden doch nicht fr alle Filme angeboten.
		/*
		if($high_resolution) {
			$movie_provider .= '_hi';
		} else {
			$movie_provider .= '_lo';
		}
		*/
		
	//	$movie_url .= ".flv";
	/*	if( $startframe != "" ) {
			$movie_url .= '?start=' . '40000000';//$startframe);
		}
	*/
		return $movie_provider;
	}
	
	function GetMovieUrl ($ident_url, $high_resolution = true) {
		if($media_id = IWFCampusmedienLitList::GetMediaId($ident_url)) {
			$movie_url = CAMPUSMEDIEN_FLASH_MEDIA_URL . $media_id . '.flv';
			
			// verschiedene Auflsungen werden doch nicht fr alle Filme angeboten.
			/*
			if($high_resolution) {
				$movie_url .= '_hi.flv';
			} else {
				$movie_url .= '_lo.flv';
			}
			*/
		
			return $movie_url;
		}
		return '';
	}
	
	function GetMediaId ($ident_url) {
		if( ereg( 'code=([0-9]+)', $ident_url, $treffer ) ) {
			return $treffer[1];
		}
		return false;
	}
	
	function insertList ($params) {
		$db =& new DB_Seminar();
		$query = "SELECT list_id FROM plugin_campusmedien_lit_list WHERE range_id = '{$this->range_id}'";
		$db->query($query);
		while ($db->next_record()) {
			return false;
		}
		$query = "INSERT plugin_campusmedien_lit_list SET range_id = '{$this->range_id}', list_id = '{$params['list_id']}', note = '{$params['note']}', chdate = UNIX_TIMESTAMP()";
		$db->query($query);
		if ($db->affected_rows()) {
			return parent::insertList($params);
		}
		return false;
	}
	
	function haveList () {
		$db =& new DB_Seminar();
		$query = "SELECT list_id FROM plugin_campusmedien_lit_list c WHERE c.range_id = '{$this->range_id}'";
		$db->query($query);
		while ($db->next_record()) {
			$query = "SELECT list_id FROM lit_list WHERE list_id = '" . $db->f('list_id') . "'";
			$db->query($query);
			while ($db->next_record()) {
				return $db->f('list_id');
			}
			$this->deletePluginList();
			return false;
		}
		return false;
	}
	
	function deletePluginList () {
		$db =& new DB_Seminar();
		$query = "DELETE FROM plugin_campusmedien_lit_list WHERE range_id = '{$this->range_id}'";
		$db->query($query);
		if ($db->affected_rows()) {
			return true;
		}
		return false;
	}
	
	function deleteList ($list_id) {
		$this->deletePluginList();
		return parent::deleteList($list_id);
	}
	
	function updateList ($params) {
		$db =& new DB_Seminar();
		$query = "SELECT list_id FROM plugin_campusmedien_lit_list WHERE range_id = '{$this->range_id}'";
		$db->query($query);
		while ($db->next_record()) {
			$db->query("UPDATE plugin_campusmedien_lit_list SET note = '{$params['note']}', chdate = UNIX_TIMESTAMP()");
			parent::updateList($params);
			return true;
		}
		return false;
	}
	
	function isCatalogIdInList ($catalog_id) {
		return isset($this->tree_data[$catalog_id]);
	}
	
	function GetChangeDate ($range_id) {
		$db =& new DB_Seminar();
		$query = "SELECT list_id, chdate FROM plugin_campusmedien_lit_list WHERE range_id = '$range_id'";
		$db->query($query);
		$change_date_plugin = 0;
		while ($db->next_record()) {
			$change_date_plugin = $db->f('chdate');
		}
		$query = "SELECT chdate FROM lit_list WHERE list_id = '" . $db->f('list_id') . "'";
		$db->query($query);
		while ($db->next_record()) {
			if ($change_date_plugin > $db->f('chdate')) {
				return $change_date_plugin;
			}
			return $db->f('chdate');
		}
		return 0;
	}
	
}


?>
